Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMealy_insert.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMealy_insert.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMealy_insert.cpp	(revision 88)
@@ -27,9 +27,28 @@
 
     // ~~~~~[ Output "memory_in" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    
+    // Initialisation
+    internal_MEMORY_IN_PORT = 0;
+    Tcontrol_t ack [_param->_nb_inst_memory];
+    for (uint32_t i=0; i<_param->_nb_inst_memory; i++)
+      ack [i] = 0;
 
+    // find first valid entry
     // store queue is never full (pointer is manage by rename stage)
-    internal_MEMORY_IN_ACK = is_operation_memory_store(PORT_READ(in_MEMORY_IN_OPERATION)) or not _speculative_access_queue_control->full();
+    for (uint32_t i=0; i<_param->_nb_inst_memory; i++)
+      if (PORT_READ(in_MEMORY_IN_VAL [i]))
+	{
+	  internal_MEMORY_IN_ACK = is_operation_memory_store(PORT_READ(in_MEMORY_IN_OPERATION [i])) or not _speculative_access_queue_control->full();
 
-    PORT_WRITE(out_MEMORY_IN_ACK, internal_MEMORY_IN_ACK);
+	  if (internal_MEMORY_IN_ACK)
+	    {
+	      ack [i] = 1;
+	      internal_MEMORY_IN_PORT = i;
+	      break; // end
+	    }
+	}
+
+    for (uint32_t i=0; i<_param->_nb_inst_memory; i++)
+      PORT_WRITE(out_MEMORY_IN_ACK [i], ack [i]);
 
     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMoore.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMoore.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMoore.cpp	(revision 88)
@@ -4,5 +4,5 @@
  * $Id$
  *
- * [ Description ]
+ * [ Description ]
  * 
  */
@@ -26,5 +26,5 @@
     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
 
-    // ~~~~~[ Interface "memory_out" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface "memory_out" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
     Tcontext_t         memory_out_context_id    = 0;
@@ -110,29 +110,30 @@
       }
     // write output
-    PORT_WRITE(out_MEMORY_OUT_VAL          , internal_MEMORY_OUT_VAL);
+    PORT_WRITE(out_MEMORY_OUT_VAL          [0], internal_MEMORY_OUT_VAL);
 
     if (_param->_have_port_context_id)
-    PORT_WRITE(out_MEMORY_OUT_CONTEXT_ID   , memory_out_context_id   );
+    PORT_WRITE(out_MEMORY_OUT_CONTEXT_ID   [0], memory_out_context_id   );
     if (_param->_have_port_front_end_id)
-    PORT_WRITE(out_MEMORY_OUT_FRONT_END_ID , memory_out_front_end_id );
+    PORT_WRITE(out_MEMORY_OUT_FRONT_END_ID [0], memory_out_front_end_id );
     if (_param->_have_port_ooo_engine_id)
-    PORT_WRITE(out_MEMORY_OUT_OOO_ENGINE_ID, memory_out_ooo_engine_id);
-    if (_param->_have_port_packet_id)
-    PORT_WRITE(out_MEMORY_OUT_PACKET_ID    , memory_out_packet_id    );
-//  PORT_WRITE(out_MEMORY_OUT_OPERATION    , memory_out_operation    );
-    PORT_WRITE(out_MEMORY_OUT_TYPE         , TYPE_MEMORY             );
-    PORT_WRITE(out_MEMORY_OUT_WRITE_RD     , memory_out_write_rd     );
-    PORT_WRITE(out_MEMORY_OUT_NUM_REG_RD   , memory_out_num_reg_rd   );
-    PORT_WRITE(out_MEMORY_OUT_DATA_RD      , memory_out_data_rd      );
-//  PORT_WRITE(out_MEMORY_OUT_WRITE_RE     , memory_out_write_re     );
-//  PORT_WRITE(out_MEMORY_OUT_NUM_REG_RE   , memory_out_num_reg_re   );
-//  PORT_WRITE(out_MEMORY_OUT_DATA_RE      , memory_out_data_re      );
-    PORT_WRITE(out_MEMORY_OUT_WRITE_RE     , 0);
-    PORT_WRITE(out_MEMORY_OUT_NUM_REG_RE   , 0);
-    PORT_WRITE(out_MEMORY_OUT_DATA_RE      , 0);
-    PORT_WRITE(out_MEMORY_OUT_EXCEPTION    , memory_out_exception    );
-    PORT_WRITE(out_MEMORY_OUT_NO_SEQUENCE  , 0);
-    PORT_WRITE(out_MEMORY_OUT_ADDRESS      , 0);
-    // ~~~~~[ Interface "dache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    PORT_WRITE(out_MEMORY_OUT_OOO_ENGINE_ID[0], memory_out_ooo_engine_id);
+    if (_param->_have_port_rob_ptr)
+    PORT_WRITE(out_MEMORY_OUT_PACKET_ID    [0], memory_out_packet_id    );
+//  PORT_WRITE(out_MEMORY_OUT_OPERATION    [0], memory_out_operation    );
+    PORT_WRITE(out_MEMORY_OUT_TYPE         [0], TYPE_MEMORY             );
+    PORT_WRITE(out_MEMORY_OUT_WRITE_RD     [0], memory_out_write_rd     );
+    PORT_WRITE(out_MEMORY_OUT_NUM_REG_RD   [0], memory_out_num_reg_rd   );
+    PORT_WRITE(out_MEMORY_OUT_DATA_RD      [0], memory_out_data_rd      );
+//  PORT_WRITE(out_MEMORY_OUT_WRITE_RE     [0], memory_out_write_re     );
+//  PORT_WRITE(out_MEMORY_OUT_NUM_REG_RE   [0], memory_out_num_reg_re   );
+//  PORT_WRITE(out_MEMORY_OUT_DATA_RE      [0], memory_out_data_re      );
+    PORT_WRITE(out_MEMORY_OUT_WRITE_RE     [0], 0);
+    PORT_WRITE(out_MEMORY_OUT_NUM_REG_RE   [0], 0);
+    PORT_WRITE(out_MEMORY_OUT_DATA_RE      [0], 0);
+    PORT_WRITE(out_MEMORY_OUT_EXCEPTION    [0], memory_out_exception    );
+    PORT_WRITE(out_MEMORY_OUT_NO_SEQUENCE  [0], 0);
+    PORT_WRITE(out_MEMORY_OUT_ADDRESS      [0], 0);
+
+    // ~~~~~[ Interface "dache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
     Tcontext_t        dcache_req_context_id;
@@ -201,11 +202,11 @@
       }
 
-    PORT_WRITE(out_DCACHE_REQ_VAL       , internal_DCACHE_REQ_VAL);
+    PORT_WRITE(out_DCACHE_REQ_VAL       [0], internal_DCACHE_REQ_VAL);
     if (_param->_have_port_dcache_context_id)
-    PORT_WRITE(out_DCACHE_REQ_CONTEXT_ID, dcache_req_context_id);
-    PORT_WRITE(out_DCACHE_REQ_PACKET_ID , dcache_req_packet_id );
-    PORT_WRITE(out_DCACHE_REQ_ADDRESS   , dcache_req_address   );
-    PORT_WRITE(out_DCACHE_REQ_TYPE      , dcache_req_type      );
-    PORT_WRITE(out_DCACHE_REQ_WDATA     , dcache_req_wdata     );
+    PORT_WRITE(out_DCACHE_REQ_CONTEXT_ID[0], dcache_req_context_id);
+    PORT_WRITE(out_DCACHE_REQ_PACKET_ID [0], dcache_req_packet_id );
+    PORT_WRITE(out_DCACHE_REQ_ADDRESS   [0], dcache_req_address   );
+    PORT_WRITE(out_DCACHE_REQ_TYPE      [0], dcache_req_type      );
+    PORT_WRITE(out_DCACHE_REQ_WDATA     [0], dcache_req_wdata     );
     
     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 88)
@@ -255,6 +255,6 @@
 	// Interface "MEMORY_IN"
 	//================================================================
-
-        if ((PORT_READ(in_MEMORY_IN_VAL) == 1) and
+	
+        if ((PORT_READ(in_MEMORY_IN_VAL [internal_MEMORY_IN_PORT]) == 1) and
             (    internal_MEMORY_IN_ACK  == 1))
           {
@@ -266,10 +266,10 @@
 
 #ifdef DEBUG_TEST
-	    if (PORT_READ(in_MEMORY_IN_TYPE) != TYPE_MEMORY)
+	    if (PORT_READ(in_MEMORY_IN_TYPE [internal_MEMORY_IN_PORT]) != TYPE_MEMORY)
 	      throw ERRORMORPHEO(FUNCTION,"The type is different at 'TYPE_MEMORY'");
 #endif
-	    Toperation_t    operation            = PORT_READ(in_MEMORY_IN_OPERATION);
-	    Tgeneral_data_t address              = (PORT_READ(in_MEMORY_IN_IMMEDIAT) +
-						    PORT_READ(in_MEMORY_IN_DATA_RA ));
+	    Toperation_t    operation            = PORT_READ(in_MEMORY_IN_OPERATION[internal_MEMORY_IN_PORT]);
+	    Tgeneral_data_t address              = (PORT_READ(in_MEMORY_IN_IMMEDIAT[internal_MEMORY_IN_PORT]) +
+						    PORT_READ(in_MEMORY_IN_DATA_RA [internal_MEMORY_IN_PORT]));
 	    bool            exception_alignement = (mask_memory_access(operation) & address) != 0;
 						    
@@ -287,5 +287,5 @@
 		
 		// Write pointer is define in rename stage :
-		Tlsq_ptr_t           index         = PORT_READ(in_MEMORY_IN_STORE_QUEUE_PTR_WRITE);
+		Tlsq_ptr_t           index         = PORT_READ(in_MEMORY_IN_STORE_QUEUE_PTR_WRITE[internal_MEMORY_IN_PORT]);
 		log_printf(TRACE,Load_store_unit,FUNCTION,"   * index         : %d",index);
 		
@@ -375,15 +375,15 @@
 		    log_printf(TRACE,Load_store_unit,FUNCTION,"   * Update information");
 
-		    _store_queue [index]._context_id           = (not _param->_have_port_context_id   )?0:PORT_READ(in_MEMORY_IN_CONTEXT_ID);
-		    _store_queue [index]._front_end_id         = (not _param->_have_port_front_end_id )?0:PORT_READ(in_MEMORY_IN_FRONT_END_ID);
-		    _store_queue [index]._ooo_engine_id        = (not _param->_have_port_ooo_engine_id)?0:PORT_READ(in_MEMORY_IN_OOO_ENGINE_ID);
-		    _store_queue [index]._packet_id            = (not _param->_have_port_packet_id    )?0:PORT_READ(in_MEMORY_IN_PACKET_ID   );
+		    _store_queue [index]._context_id           = (not _param->_have_port_context_id   )?0:PORT_READ(in_MEMORY_IN_CONTEXT_ID   [internal_MEMORY_IN_PORT]);
+		    _store_queue [index]._front_end_id         = (not _param->_have_port_front_end_id )?0:PORT_READ(in_MEMORY_IN_FRONT_END_ID [internal_MEMORY_IN_PORT]);
+		    _store_queue [index]._ooo_engine_id        = (not _param->_have_port_ooo_engine_id)?0:PORT_READ(in_MEMORY_IN_OOO_ENGINE_ID[internal_MEMORY_IN_PORT]);
+		    _store_queue [index]._packet_id            = (not _param->_have_port_rob_ptr      )?0:PORT_READ(in_MEMORY_IN_PACKET_ID    [internal_MEMORY_IN_PORT]);
 		    _store_queue [index]._operation            = operation;
-		    _store_queue [index]._load_queue_ptr_write = (not _param->_have_port_load_queue_ptr)?0:PORT_READ(in_MEMORY_IN_LOAD_QUEUE_PTR_WRITE);
+		    _store_queue [index]._load_queue_ptr_write = (not _param->_have_port_load_queue_ptr)?0:PORT_READ(in_MEMORY_IN_LOAD_QUEUE_PTR_WRITE[internal_MEMORY_IN_PORT]);
 		    _store_queue [index]._address              = address;
 
 		    // reordering data
-		    _store_queue [index]._wdata                = duplicate<Tgeneral_data_t>(_param->_size_general_data,PORT_READ(in_MEMORY_IN_DATA_RB), memory_size(operation), 0);
-//                  _store_queue [index]._num_reg_rd           = PORT_READ(in_MEMORY_IN_NUM_REG_RD  );
+		    _store_queue [index]._wdata                = duplicate<Tgeneral_data_t>(_param->_size_general_data,PORT_READ(in_MEMORY_IN_DATA_RB[internal_MEMORY_IN_PORT]), memory_size(operation), 0);
+//                  _store_queue [index]._num_reg_rd           = PORT_READ(in_MEMORY_IN_NUM_REG_RD  [internal_MEMORY_IN_PORT]);
 		  }
 	      }
@@ -413,16 +413,16 @@
 		// NOTE : type "other" (lock, invalidate, flush and sync) can't make an alignement exception (access is equivalent at a 8 bits)
 		_speculative_access_queue [index]._state                = (exception == EXCEPTION_MEMORY_NONE)?SPECULATIVE_ACCESS_QUEUE_WAIT_CACHE:SPECULATIVE_ACCESS_QUEUE_WAIT_LOAD_QUEUE;
-		_speculative_access_queue [index]._context_id           = (not _param->_have_port_context_id   )?0:PORT_READ(in_MEMORY_IN_CONTEXT_ID);
-		_speculative_access_queue [index]._front_end_id         = (not _param->_have_port_front_end_id )?0:PORT_READ(in_MEMORY_IN_FRONT_END_ID);
-		_speculative_access_queue [index]._ooo_engine_id        = (not _param->_have_port_ooo_engine_id)?0:PORT_READ(in_MEMORY_IN_OOO_ENGINE_ID);
-		_speculative_access_queue [index]._packet_id            = (not _param->_have_port_packet_id    )?0:PORT_READ(in_MEMORY_IN_PACKET_ID);
+		_speculative_access_queue [index]._context_id           = (not _param->_have_port_context_id   )?0:PORT_READ(in_MEMORY_IN_CONTEXT_ID   [internal_MEMORY_IN_PORT]);
+		_speculative_access_queue [index]._front_end_id         = (not _param->_have_port_front_end_id )?0:PORT_READ(in_MEMORY_IN_FRONT_END_ID [internal_MEMORY_IN_PORT]);
+		_speculative_access_queue [index]._ooo_engine_id        = (not _param->_have_port_ooo_engine_id)?0:PORT_READ(in_MEMORY_IN_OOO_ENGINE_ID[internal_MEMORY_IN_PORT]);
+		_speculative_access_queue [index]._packet_id            = (not _param->_have_port_rob_ptr      )?0:PORT_READ(in_MEMORY_IN_PACKET_ID    [internal_MEMORY_IN_PORT]);
 
 		_speculative_access_queue [index]._operation            = operation;
-		_speculative_access_queue [index]._load_queue_ptr_write = (not _param->_have_port_load_queue_ptr)?0:PORT_READ(in_MEMORY_IN_LOAD_QUEUE_PTR_WRITE);
-		_speculative_access_queue [index]._store_queue_ptr_write= PORT_READ(in_MEMORY_IN_STORE_QUEUE_PTR_WRITE);
+		_speculative_access_queue [index]._load_queue_ptr_write = (not _param->_have_port_load_queue_ptr)?0:PORT_READ(in_MEMORY_IN_LOAD_QUEUE_PTR_WRITE[internal_MEMORY_IN_PORT]);
+		_speculative_access_queue [index]._store_queue_ptr_write= PORT_READ(in_MEMORY_IN_STORE_QUEUE_PTR_WRITE[internal_MEMORY_IN_PORT]);
 		_speculative_access_queue [index]._address              = address;
 		// NOTE : is operation is a load, then they are a result and must write in the register file
 		_speculative_access_queue [index]._write_rd             = is_operation_memory_load(operation);
-		_speculative_access_queue [index]._num_reg_rd           = PORT_READ(in_MEMORY_IN_NUM_REG_RD  );
+		_speculative_access_queue [index]._num_reg_rd           = PORT_READ(in_MEMORY_IN_NUM_REG_RD  [internal_MEMORY_IN_PORT]);
 
 		_speculative_access_queue [index]._exception            = exception;
@@ -437,5 +437,5 @@
 
         if ((    internal_MEMORY_OUT_VAL  == 1) and
-            (PORT_READ(in_MEMORY_OUT_ACK) == 1))
+            (PORT_READ(in_MEMORY_OUT_ACK[0]) == 1))
           {
 	    log_printf(TRACE,Load_store_unit,FUNCTION,"MEMORY_OUT transaction");
@@ -495,5 +495,5 @@
 
         if ((    internal_DCACHE_REQ_VAL  == 1) and
-            (PORT_READ(in_DCACHE_REQ_ACK) == 1))
+            (PORT_READ(in_DCACHE_REQ_ACK[0]) == 1))
           {
 	    log_printf(TRACE,Load_store_unit,FUNCTION,"DCACHE_REQ");
@@ -598,5 +598,5 @@
 	// Interface "DCACHE_RSP"
 	//================================================================
-        if ((PORT_READ(in_DCACHE_RSP_VAL)== 1) and
+        if ((PORT_READ(in_DCACHE_RSP_VAL[0])== 1) and
             (    internal_DCACHE_RSP_ACK == 1))
           {
@@ -604,8 +604,8 @@
 
 	    // don't use context_id : because there are one queue for all thread
-	    //Tcontext_t      context_id = PORT_READ(in_DCACHE_RSP_CONTEXT_ID); 
-	    Tpacket_t       packet_id  = PORT_READ(in_DCACHE_RSP_PACKET_ID );
-	    Tdcache_data_t  rdata      = PORT_READ(in_DCACHE_RSP_RDATA     );
-	    Tdcache_error_t error      = PORT_READ(in_DCACHE_RSP_ERROR     );
+	    //Tcontext_t      context_id = PORT_READ(in_DCACHE_RSP_CONTEXT_ID[0]); 
+	    Tpacket_t       packet_id  = PORT_READ(in_DCACHE_RSP_PACKET_ID [0]);
+	    Tdcache_data_t  rdata      = PORT_READ(in_DCACHE_RSP_RDATA     [0]);
+	    Tdcache_error_t error      = PORT_READ(in_DCACHE_RSP_ERROR     [0]);
 
 	    log_printf(TRACE,Load_store_unit,FUNCTION," * original packet_id : %d", packet_id);
@@ -662,5 +662,5 @@
 	
 	
-#if DEBUG>=DEBUG_TRACE
+#if defined(DEBUG) and (DEBUG>=DEBUG_TRACE)
 	// ***** dump store queue
 	std::cout << "Dump STORE_QUEUE :" << std::endl
@@ -694,17 +694,19 @@
 		 << _load_queue[j] << std::endl;
 	  }
-	
 #endif
 	
 #ifdef STATISTICS
-	for (uint32_t i=0; i<_param->_size_store_queue; i++)
-	  if (_store_queue[i]._state != STORE_QUEUE_EMPTY)
-	    (*_stat_use_store_queue) ++;
-	for (uint32_t i=0; i<_param->_size_speculative_access_queue; i++)
-	  if (_speculative_access_queue[i]._state != SPECULATIVE_ACCESS_QUEUE_EMPTY)
-	    (*_stat_use_speculative_access_queue) ++;
-	for (uint32_t i=0; i<_param->_size_load_queue; i++)
-	  if (_load_queue[i]._state != LOAD_QUEUE_EMPTY)
-	    (*_stat_use_load_queue) ++;
+        if (usage_is_set(_usage,USE_STATISTICS))
+          {
+            for (uint32_t i=0; i<_param->_size_store_queue; i++)
+              if (_store_queue[i]._state != STORE_QUEUE_EMPTY)
+                (*_stat_use_store_queue) ++;
+            for (uint32_t i=0; i<_param->_size_speculative_access_queue; i++)
+              if (_speculative_access_queue[i]._state != SPECULATIVE_ACCESS_QUEUE_EMPTY)
+                (*_stat_use_speculative_access_queue) ++;
+            for (uint32_t i=0; i<_param->_size_load_queue; i++)
+              if (_load_queue[i]._state != LOAD_QUEUE_EMPTY)
+                (*_stat_use_load_queue) ++;
+          }
 #endif
       }
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp	(revision 88)
@@ -26,4 +26,6 @@
 			  Tspeculative_load_t speculative_load       ,
 			  uint32_t            nb_bypass_memory       ,
+			  uint32_t            nb_cache_port          ,
+			  uint32_t            nb_inst_memory         ,
 			  uint32_t            nb_context             ,
 			  uint32_t            nb_front_end           ,
@@ -33,97 +35,120 @@
 			  uint32_t            size_special_data      ,
 			  uint32_t            nb_general_register    ,
-			  uint32_t            nb_special_register    ):
-    _size_store_queue        (size_store_queue       ),
-    _size_load_queue         (size_load_queue        ),
-    _size_speculative_access_queue (size_speculative_access_queue),
-    _nb_port_check           (nb_port_check          ),
-    _speculative_load        (speculative_load       ),
-    _nb_bypass_memory        (nb_bypass_memory       ),
-    _nb_context              (nb_context             ),
-    _nb_front_end            (nb_front_end           ),
-    _nb_ooo_engine           (nb_ooo_engine          ),
-    _nb_packet               (nb_packet              ),
-    _size_general_data       (size_general_data      ),
-    _size_special_data       (size_special_data      ),
-    _nb_general_register     (nb_general_register    ),
-    _nb_special_register     (nb_special_register    ),
-    
-    _size_address_store_queue              (log2(size_store_queue             )),
-    _size_address_load_queue               (log2(size_load_queue              )),
-    _size_address_speculative_access_queue (log2(size_speculative_access_queue)),
-
-    _size_context_id         (log2(nb_context         )),
-    _size_front_end_id       (log2(nb_front_end       )),
-    _size_ooo_engine_id      (log2(nb_ooo_engine      )),
-    _size_packet_id          (log2(nb_packet          )),
-    _size_general_register   (log2(nb_general_register)),
-    _size_special_register   (log2(nb_special_register)),
-    _size_dcache_context_id  (_size_context_id + _size_front_end_id + _size_ooo_engine_id),
-    _size_dcache_packet_id   ((log2((size_store_queue>size_load_queue)?size_store_queue:size_load_queue))+1),
-
-    _have_port_context_id        (_size_context_id   >0),
-    _have_port_front_end_id      (_size_front_end_id >0),
-    _have_port_ooo_engine_id     (_size_ooo_engine_id>0),
-    _have_port_packet_id         (_size_packet_id    >0),
-    _have_port_dcache_context_id (_size_dcache_context_id>0),
-    _have_port_load_queue_ptr    (_size_load_queue>1),
-
-    _mask_address_lsb            (gen_mask<Tdcache_address_t>(log2(size_general_data/8))),
-    _mask_address_msb            (gen_mask<Tdcache_address_t>(size_general_data) << log2(size_general_data/8))
+			  uint32_t            nb_special_register    ,
+                          bool                is_toplevel)
   {
     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
+
+    _size_store_queue                      = size_store_queue       ;
+    _size_load_queue                       = size_load_queue        ;
+    _size_speculative_access_queue         = size_speculative_access_queue;
+    _nb_port_check                         = nb_port_check          ;
+    _speculative_load                      = speculative_load       ;
+    _nb_bypass_memory                      = nb_bypass_memory       ;
+    _nb_cache_port                         = nb_cache_port          ;
+    _nb_inst_memory                        = nb_inst_memory         ;
+    _nb_context                            = nb_context             ;
+    _nb_front_end                          = nb_front_end           ;
+    _nb_ooo_engine                         = nb_ooo_engine          ;
+    _nb_packet                             = nb_packet              ;
+    _nb_general_register                   = nb_general_register    ;
+    _nb_special_register                   = nb_special_register    ;
+    
+    _size_speculative_access_queue_ptr     = log2(size_speculative_access_queue);
+
+    _size_dcache_context_id                = log2(nb_context) + log2(nb_front_end) + log2(nb_ooo_engine);
+    _size_dcache_packet_id                 = (log2((size_store_queue>size_load_queue)?size_store_queue:size_load_queue))+1;
+
+    _have_port_dcache_context_id           = _size_dcache_context_id>0;
+
+    _mask_address_lsb                      = gen_mask<Tdcache_address_t>(log2(size_general_data/8));
+    _mask_address_msb                      = gen_mask<Tdcache_address_t>(size_general_data) << log2(size_general_data/8);
+
     test();
+
+    if (is_toplevel)
+      {
+        _size_context_id                       = log2(nb_context         );
+        _size_front_end_id                     = log2(nb_front_end       );
+        _size_ooo_engine_id                    = log2(nb_ooo_engine      );
+        _size_rob_ptr                          = log2(nb_packet          );
+        _size_general_register                 = log2(nb_general_register);
+        _size_special_register                 = log2(nb_special_register);
+        _size_store_queue_ptr                  = log2(size_store_queue   );
+        _size_load_queue_ptr                   = log2(size_load_queue    );
+        _size_general_data                     = size_general_data      ;
+        _size_special_data                     = size_special_data      ;
+
+        _have_port_context_id                  = _size_context_id    >0;
+        _have_port_front_end_id                = _size_front_end_id  >0;
+        _have_port_ooo_engine_id               = _size_ooo_engine_id >0;
+        _have_port_rob_ptr                     = _size_rob_ptr       >0;
+        _have_port_load_queue_ptr              = _size_load_queue_ptr>0;
+
+        copy();
+      }
+
     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
   };
   
+// #undef  FUNCTION
+// #define FUNCTION "Load_store_unit::Parameters (copy)"
+//   Parameters::Parameters (Parameters & param):
+//     _size_store_queue        (param._size_store_queue       ),
+//     _size_load_queue         (param._size_load_queue        ),
+//     _size_speculative_access_queue (param._size_speculative_access_queue),
+//     _nb_port_check           (param._nb_port_check          ),
+//     _speculative_load        (param._speculative_load       ),
+//     _nb_bypass_memory        (param._nb_bypass_memory       ),
+//     _nb_cache_port           (param._nb_cache_port          ),
+//     _nb_inst_memory          (param._nb_inst_memory         ),
+//     _nb_context              (param._nb_context             ),
+//     _nb_front_end            (param._nb_front_end           ),
+//     _nb_ooo_engine           (param._nb_ooo_engine          ),
+//     _nb_packet               (param._nb_packet              ),
+//     _size_general_data       (param._size_general_data      ),
+//     _size_special_data       (param._size_special_data      ),
+//     _nb_general_register     (param._nb_general_register    ),
+//     _nb_special_register     (param._nb_special_register    ),
+
+//     _size_address_store_queue              (param._size_address_store_queue             ),
+//     _size_address_load_queue               (param._size_address_load_queue              ),
+//     _size_address_speculative_access_queue (param._size_address_speculative_access_queue),
+
+//     _size_context_id         (param._size_context_id        ),
+//     _size_front_end_id       (param._size_front_end_id      ),
+//     _size_ooo_engine_id      (param._size_ooo_engine_id     ),
+//     _size_packet_id          (param._size_packet_id         ),
+//     _size_general_register   (param._size_general_register  ),
+//     _size_special_register   (param._size_special_register  ),
+//     _size_dcache_context_id  (param._size_dcache_context_id ),
+//     _size_dcache_packet_id   (param._size_dcache_packet_id  ),
+
+//     _have_port_context_id    (param._have_port_context_id   ),
+//     _have_port_front_end_id  (param._have_port_front_end_id ),
+//     _have_port_ooo_engine_id (param._have_port_ooo_engine_id),
+//     _have_port_packet_id     (param._have_port_packet_id    ),
+//     _have_port_dcache_context_id(param._have_port_dcache_context_id),
+//     _have_port_load_queue_ptr(param._have_port_load_queue_ptr),
+
+//     _mask_address_lsb        (param._mask_address_lsb),
+//     _mask_address_msb        (param._mask_address_msb)
+//   {
+//     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
+//     test();
+//     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
+//   };
+
 #undef  FUNCTION
-#define FUNCTION "Load_store_unit::Parameters (copy)"
-  Parameters::Parameters (Parameters & param):
-    _size_store_queue        (param._size_store_queue       ),
-    _size_load_queue         (param._size_load_queue        ),
-    _size_speculative_access_queue (param._size_speculative_access_queue),
-    _nb_port_check           (param._nb_port_check          ),
-    _speculative_load        (param._speculative_load       ),
-    _nb_bypass_memory        (param._nb_bypass_memory       ),
-    _nb_context              (param._nb_context             ),
-    _nb_front_end            (param._nb_front_end           ),
-    _nb_ooo_engine           (param._nb_ooo_engine          ),
-    _nb_packet               (param._nb_packet              ),
-    _size_general_data       (param._size_general_data      ),
-    _size_special_data       (param._size_special_data      ),
-    _nb_general_register     (param._nb_general_register    ),
-    _nb_special_register     (param._nb_special_register    ),
-
-    _size_address_store_queue              (param._size_address_store_queue             ),
-    _size_address_load_queue               (param._size_address_load_queue              ),
-    _size_address_speculative_access_queue (param._size_address_speculative_access_queue),
-
-    _size_context_id         (param._size_context_id        ),
-    _size_front_end_id       (param._size_front_end_id      ),
-    _size_ooo_engine_id      (param._size_ooo_engine_id     ),
-    _size_packet_id          (param._size_packet_id         ),
-    _size_general_register   (param._size_general_register  ),
-    _size_special_register   (param._size_special_register  ),
-    _size_dcache_context_id  (param._size_dcache_context_id ),
-    _size_dcache_packet_id   (param._size_dcache_packet_id  ),
-
-    _have_port_context_id    (param._have_port_context_id   ),
-    _have_port_front_end_id  (param._have_port_front_end_id ),
-    _have_port_ooo_engine_id (param._have_port_ooo_engine_id),
-    _have_port_packet_id     (param._have_port_packet_id    ),
-    _have_port_dcache_context_id(param._have_port_dcache_context_id),
-    _have_port_load_queue_ptr(param._have_port_load_queue_ptr),
-
-    _mask_address_lsb        (param._mask_address_lsb),
-    _mask_address_msb        (param._mask_address_msb)
+#define FUNCTION "Load_store_unit::~Parameters"
+  Parameters::~Parameters (void) 
   {
     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
-    test();
     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
   };
 
 #undef  FUNCTION
-#define FUNCTION "Load_store_unit::~Parameters"
-  Parameters::~Parameters () 
+#define FUNCTION "Load_store_unit::copy"
+  void Parameters::copy (void) 
   {
     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters_msg_error.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters_msg_error.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters_msg_error.cpp	(revision 88)
@@ -32,5 +32,5 @@
 	{
 	  if (not (_nb_bypass_memory == 0))
-	    test.error("Bypass memory is not supported. Please wait a next revision.");
+	    test.error(_("Bypass memory is not supported. Please wait a next revision.\n"));
  
 	  break;
@@ -42,7 +42,7 @@
 	{
 	  if (not (_nb_bypass_memory == 0))
-	    test.error("In the load scheme '"+toString(_speculative_load)+"', they have none bypass.");
+	    test.error(toString(_("In the load scheme '%s', they have none bypass.\n"),toString(_speculative_load).c_str()));
 
-	  test.error("Speculative load scheme '"+toString(_speculative_load)+"' is not supported. Please wait a next revision.");
+	  test.error(toString(_("Speculative load scheme '%s' is not supported. Please wait a next revision.\n"),toString(_speculative_load).c_str()));
 	  break;
 	}
@@ -50,8 +50,14 @@
 
     if (not (_size_store_queue >= 2))
-      test.error("Store queue must have at less two slot.");
+      test.error(_("Store queue must have at less two slot.\n"));
 
     if (not (_nb_bypass_memory <= _size_load_queue))
-      test.error("Bypass number must be less than load_queue's size.");
+      test.error(_("Bypass number must be less than load_queue's size.\n"));
+
+    if (_nb_cache_port > 1)
+      test.warning(_("nb_cache_port > 1 is unsupported (Coming Soon).\n")); 
+
+    if (_nb_inst_memory > 1)
+      test.warning(_("nb_inst_memory > 1 is unsupported (Coming Soon).\n")); 
 
     log_printf(FUNC,Load_store_unit,FUNCTION,"End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/Makefile	(revision 88)
@@ -24,4 +24,6 @@
 library_clean			: Read_queue_library_clean
 
+local_clean			:
+
 include                         ../Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
